
clear all

symbols_C = {'C', 'D', 'G', 'J', 'S', 'T', 'Z', 'b', 'd', 'f', 'g', 'h', 'k',...
    'l', 'm', 'n', 'p', 'r', 's', 't', 'v', 'w', 'y', 'z'};
symbols_V = {'@', 'A', 'E', 'I', 'O', 'R', 'U', 'W', 'Y', 'a', 'c', 'e', 'i',...
    'o', 'u'};

button_order = {'ch in church', 'th in this', 'ng in sing', 'j in judge',...
    'sh in she', 'th in think', 's in pleasure', 'b in bee', 'd in dog',...
    'f in fish', 'g in dog', 'h in he', 'c in cat', 'l in look', 'm in man',...
    'n in man', 'p in pen', 'r in real', 's in see', 't in cat', 'v in vow',...
    'w in win', 'y in you', 'z in zoo', 'a in hat', 'u in hut', 'e in bet',...
    'i in hit', 'oy in boy', 'ir in bird', 'u in put', 'ow in how',...
    'y in why', 'o in cot', 'au in caught', 'ai in bait', 'ee in bee',...
    'oa in boat', 'oo in boo'};

% column_choice_new = {'(ch)', '(dh)', '(ng)', '(j)', '(sh)', '(th)', '(zh)',...
%     '(b)', '(d)', '(f)', '(g)','(h)', '(k)', '(l)', '(m)', '(n)','(p)',...
%     '(r)', '(s)', '(t)', '(v)', '(w)', '(y)', '(z)', '(ae)',...
%     '(U)', '(e)', '(i)', '(oy)', '(ir)', '(u)', '(ow)', '(ai)', '(a)',...
%     '(au)', '(ei)', '(ee)', '(oa)', '(oo)'};

column_choice_new = {'(ch)', '(dh)', '(ng)', '(j)', '(sh)', '(th)', '(zh)',...
    '(b)', '(d)', '(f)', '(g)','(h)', '(k)', '(l)', '(m)', '(n)','(p)',...
    '(r)', '(s)', '(t)', '(v)', '(w)', '(y)', '(z)', '(a)', '(ae)',...
    '(i)', '(ei)', '(U)', '(e)', '(oy)', '(ir)', '(u)', '(ow)', '(ai)',...
    '(au)', '(ee)', '(oa)', '(oo)'};


% Consonant and Vowel orders for columns of CM is same as C_choice_new and
% V_choice_new
% C_choice_new = {'(ch)', '(dh)', '(ng)', '(j)', '(sh)', '(th)', '(zh)',...
%     '(b)', '(d)', '(f)', '(g)','(h)', '(k)', '(l)', '(m)', '(n)','(p)',...
%     '(r)', '(s)', '(t)', '(v)', '(w)', '(y)', '(z)'};
% 
% V_choice_new = { '(a)', '(ae)', '(i)', '(ei)', '(U)', '(e)', '(oy)',...
%     '(ir)', '(u)', '(ow)', '(ai)', '(au)', '(ee)', '(oa)', '(oo)'};


% 
column_choice_new = {'xc', 'xd', 'xg', 'xj', 'xs', 'xt', 'xz', 'b', 'd',...
    'f', 'g', 'h', 'k', 'l', 'm', 'n', 'p', 'r', 's', 't', 'v', 'w', 'y',...
    'z', 'a', 'xq', 'xi', 'e', 'xa', 'xe', 'xo', 'xr', 'xu', 'xw', 'xy',...
    'c', 'i', 'o', 'u'};
column_choice_old = {'xc', 'xd', 'xg', 'xj', 'xs', 'xt', 'xz', 'b', 'd',...
    'f', 'g', 'h', 'k', 'l', 'm', 'n', 'p', 'r', 's', 't', 'v', 'w', 'y',...
    'z', 'xq', 'xa', 'xe', 'xi', 'xo', 'xr', 'xu', 'xw', 'xy', 'a',...
    'c', 'e', 'i', 'o', 'u'};

% Consonant and Vowel orders for columns of CM is same as C_choice_old and
% row_choice_V

C_choice_old = {'xc', 'xd', 'xg', 'xj', 'xs', 'xt', 'xz', 'b', 'd', 'f',...
    'g', 'h', 'k', 'l', 'm', 'n', 'p', 'r', 's', 't', 'v', 'w', 'y', 'z'};
V_choice_new = {'a', 'xq', 'xi', 'e', 'xa', 'xe', 'xo', 'xr', 'xu', 'xw',...
    'xy', 'c', 'i', 'o', 'u'};
V_choice_old = {'xq', 'xa', 'xe', 'xi', 'xo', 'xr', 'xu', 'xw', 'xy', 'a',...
    'c', 'e', 'i', 'o', 'u'};

row_choice = {'xc', 'xd', 'xg', 'xj', 'xs', 'xt', 'xz', 'b', 'd', 'f', 'g',...
    'h', 'k', 'l', 'm', 'n', 'p', 'r', 's', 't', 'v', 'w', 'y', 'z', 'a',...
    'xq', 'xi', 'e', 'xa', 'xe', 'xo', 'xr', 'xu', 'xw', 'xy', 'c', 'i',...
    'o', 'u'};

% row_choice_V = {'xq', 'xa', 'xe', 'xi', 'xo', 'xr', 'xu', 'xw', 'xy', 'a',...
%     'c', 'e', 'i', 'o', 'u'};


d = dir('../data/l*.log');
temp = dir('../data/L*.log');
d(length(d)+[1:length(temp)]) = temp;

L_C = length(C_choice_old);
L_V = length(V_choice_old);

CM_C_new = zeros(L_C);
CM_V_new = zeros(L_V);
CM_C_old = zeros(L_C);
CM_V_old = zeros(L_V);

for i = 1:length(d)
    d(i).ver = str2num(d(i).name(end-4));
%     d(i).ver
    f = fopen(['../data/' d(i).name],'r');
    x = fscanf(f,'%c');
    fclose(f);
    
    date(i) = regexp(d(i).name,'\w+_(?<day>\d\d)-(?<month>\w\w\w)-(?<year>\d\d\d\d)_','names');
    
    if d(i).ver == 2
        data = regexp(x,'STIM=(?<stim>\w+)\s+RESP=\((?<resp1>\w+)\)\((?<resp2>\w+)\)\s','names');
        N(i) = length(data);
        clear x
        for j = 1:length(data)
            data(j).resp = [data(j).resp1 data(j).resp2];
            temp = strmatch(data(j).resp1, column_choice_new, 'exact');
            if temp > 24
                c_V = temp - 24;
                c_C = strmatch(data(j).resp2, C_choice_old, 'exact');
                data(j).resp_CV = 0;
            else
                c_C = temp;
                c_V = strmatch(data(j).resp2, V_choice_new, 'exact');
                data(j).resp_CV = 1;
            end
            
            temp = strmatch(data(j).stim(1), row_choice, 'exact');
            if isempty(temp)
                temp = strmatch(data(j).stim(1:2), row_choice, 'exact');
            end
            stim = strrep(data(j).stim, row_choice{temp}, '');
            if temp > 24
                r_V = temp - 24;
                r_C = strmatch(stim, C_choice_old, 'exact');
                data(j).stim_CV = 0;
            else
                r_C = temp;
                r_V = strmatch(stim, V_choice_new, 'exact');
                data(j).stim_CV = 1;
            end
            CM_C_new(r_C,c_C) = CM_C_new(r_C,c_C) + 1;
            CM_V_new(r_V,c_V) = CM_V_new(r_V,c_V) + 1;
        end
        
    else
        data = regexp(x,'STIM=(?<stim>\w+)\s+RESP=(?<resp>\w+)\s','names');
        N(i) = length(data);
        clear x
        for j = 1:length(data)
            if strmatch('XXX_', data(j).resp)
                data(j).resp = data(j).resp(5:end);
            end
            temp = strmatch(data(j).resp(1), column_choice_new, 'exact');
            if isempty(temp)
                temp = strmatch(data(j).resp(1:2), column_choice_new, 'exact');
            end
            resp = strrep(data(j).resp, column_choice_new{temp}, '');
            if temp > 24
                c_V = temp - 24;
                c_C = strmatch(resp, C_choice_old, 'exact');
                data(j).resp_CV = 0;
            else
                c_C = temp;
                c_V = strmatch(resp, V_choice_new, 'exact');
                data(j).resp_CV = 1;
            end
            
            temp = strmatch(data(j).stim(1), row_choice, 'exact');
            if isempty(temp)
                temp = strmatch(data(j).stim(1:2), row_choice, 'exact');
            end
            stim = strrep(data(j).stim, row_choice{temp}, '');
            if temp > 24
                r_V = temp - 24;
                r_C = strmatch(stim, C_choice_old, 'exact');
                data(j).stim_CV = 0;
            else
                r_C = temp;
                r_V = strmatch(stim, V_choice_new, 'exact');
                data(j).stim_CV = 1;
            end
            CM_C_old(r_C,c_C) = CM_C_old(r_C,c_C) + 1;
            CM_V_old(r_V,c_V) = CM_V_old(r_V,c_V) + 1;
        end
    end
    
end

get_date
break

CM_C = CM_C_old + CM_C_new;
CM_V = CM_V_old + CM_V_new;

save('CM_Laura.mat','CM_C','CM_V','C_choice_old','V_choice_old')
break

figure(1)
colormap('gray')
colormap(flipud(colormap))
L = length(V_choice_new);
imagesc(log10(CM_V./(sum(CM_V,2)*ones(1,length(CM_V)))),[-2 0])
set(gca,'XTick', 1:L, 'XTickLabel', symbols_V);
set(gca,'YTick', 1:L, 'YTickLabel', symbols_V);
c = colorbar('NorthOutside');
set(c, 'XTick', -3:0, 'XTickLabel', [0.001 0.01 0.1 1])
axis square
saveas(gca, 'CM_V_L.fig', 'fig')
print('-depsc2', 'CM_V_L')
close

figure(2)
colormap('gray')
colormap(flipud(colormap))
L = length(C_choice_new);
imagesc(log10(CM_C./(sum(CM_C,2)*ones(1,length(CM_C)))),[-2 0])
set(gca,'XTick', 1:L, 'XTickLabel', symbols_C);
set(gca,'YTick', 1:L, 'YTickLabel', symbols_C);
c = colorbar('NorthOutside');
set(c, 'XTick', -3:0, 'XTickLabel', [0.001 0.01 0.1 1])
axis square
saveas(gca, 'CM_C_L.fig', 'fig')
print('-depsc2', 'CM_C_L')
close
