
clear all

subid = {'Laura','Tony','Angela','Norene', 'Teddy'};

% p_C = zeros(24,length(subid));
% N_C = zeros(24,length(subid));
% p_V = zeros(15,length(subid));
% N_V = zeros(15,length(subid));

for s = 2:length(subid)
    load(['CM_' subid{s} '.mat'])
    
    f = fopen(['NSCMProfile_' subid{s} '.txt'],'w');
    fprintf(f,'%s : NSCM Task\r\n', subid{s});
    
    % Initial Position
    CM_C_new = CM_C(:,:,1);
    CM_V_new = CM_V(:,:,1);
    
    fprintf(f,'Initial Position \r\n');
    WriteTable(f, CM_C_new, CM_V_new, C_choice_old, V_choice_old)
    
    % Final Position
    CM_C_new = CM_C(:,:,2);
    CM_V_new = CM_V(:,:,2);
    
    fprintf(f,'Final Position \r\n');
    WriteTable(f, CM_C_new, CM_V_new, C_choice_old, V_choice_old)
      
    
    % Overall
    CM_C_new = sum(CM_C,3);
    CM_V_new = sum(CM_V,3);
    
    fprintf(f,'Overall (Position-independent) \r\n');
    WriteTable(f, CM_C_new, CM_V_new, C_choice_old, V_choice_old)
    
    fclose(f);
    
end

break

sum([p_C; p_V])
sum([N_C; N_V])
sum([p_C; p_V])./sum([N_C; N_V])

f = fopen(['NSCMScores.txt'],'w+');
fprintf(f,'Phone');
for i = 1:length(subid)
    fprintf(f,',%s',subid{i});
end
fprintf(f,'\r\n');
for j = 1:length(p_C)
    fprintf(f,'%s',C_choice_old{j});
    for i = 1:length(subid)
        fprintf(f,',%2.1f/%2.1f=%2.2f',p_C(j,i),N_C(j,i),(p_C(j,i)/N_C(j,i))*100);
    end
    fprintf(f,'\r\n');
end
for j = 1:length(p_V)
    fprintf(f,'%s',V_choice_old{j});
    for i = 1:length(subid)
        fprintf(f,',%2.1f/%2.1f=%2.2f',p_V(j,i),N_V(j,i),(p_V(j,i)/N_V(j,i))*100);
    end
    fprintf(f,'\r\n');
end
fclose(f);

