clear all

Syl_sequence = {'CV', 'VC', 'CVC', 'VCV', 'CCV', 'VCC'};
V_sequence = {'xq', 'xa', 'xe', 'xi', 'xo', 'xr', 'xu', 'xw', 'xy', 'a', 'c', 'e', 'i', 'o', 'u'};
C_sequence = {'xc', 'xd', 'xg', 'xj', 'xs', 'xt', 'xz', 'b', 'd', 'f', 'g', 'h', 'k', 'l', 'm', 'n', 'p', 'r', 's', 't', 'v', 'w', 'y', 'z'};


subid = 'Angela';

load(['Data_' subid '.mat'])

% temp = find(N);
% N = N(temp);
% date = date(temp);
% clear temp

for i = 1:length(date)
    M(i) = month([date(i).day '-' date(i).month '-' date(i).year]);
    D(i) = str2num(date(i).day);
    Y(i) = str2num(date(i).year);
end

d = [Y(:) M(:) D(:) N(:)];
[dummy, I] = sort(d(:,1));
d = d(I,:);
[dummy1, S, dummy2] = unique(d(:,1),'rows');
S = [0; S];
for i = 2:length(S)
    [dummy, I] = sort(d(S(i-1)+1:S(i),2));
    d(S(i-1)+1:S(i),:) = d(S(i-1)+I,:);
end
[dummy1, S, dummy2] = unique(d(:,1:2),'rows');
S = [0; S];
for i = 2:length(S)
    [dummy, I] = sort(d(S(i-1)+1:S(i),3));
    d(S(i-1)+1:S(i),:) = d(S(i-1)+I,:);
end

[U, S, dummy] = unique(d(:,1:3),'rows');
S = [0; S];
D = d;
L = 0;
Save = 1;
clear N d dummy dummy1 dummy2

for f = 1:length(U)
    N(f) = sum(D(S(f)+1:S(f+1),4));
    
    if U(f,3) < 10
        d = ['0' num2str(U(f,3))];
    else
        d = num2str(U(f,3));
    end
    if U(f,2) < 10
        m = ['0' num2str(U(f,2))];
    else
        m = num2str(U(f,2));
    end
    
    fid = fopen(['IPATranscript/IPATranscription_' subid '_' m '-' d '-07.xls'],'r');
    if fid ~= -1
        fclose(fid);
        [n, t, r] = xlsread(['IPATranscript/IPATranscription_' subid '_' m '-' d '-07.xls']);
        clear r
        n(isnan(n)) = 0;
        n = n(:,2:end);
        t = t(:,2:end);
        L_IPA = size(n,1);
        % remove zero lines at the beginning
        while isempty(find(n(1,:)))
            n = n(2:L_IPA,:);
            L_IPA = L_IPA - 1;
        end
        % remove zero lines at the end
        while isempty(find(n(L_IPA,:)))
            L_IPA = L_IPA - 1;
            n = n(1:L_IPA,:);
        end

        if L_IPA < N(f)
            disp(['# of trials do not match : N(f) = ' num2str(N(f)) ' , File Length = ' num2str(L_IPA)])
        elseif L_IPA > N(f)
            disp(['# of trials do not match : N(f) = ' num2str(N(f)) ' , File Length = ' num2str(L_IPA)])
            disp(['Ignoring the extra transcriptions'])
            L_IPA = N(f);
            n = n(1:L_IPA,:);
        end

        data_temp = data(L+[1:L_IPA]);

        for i = 1:L_IPA
            clear C V resp

            data_IPA(L+i).stim = data_temp(i).stim;
            data_IPA(L+i).talker = data_temp(i).talker;
            resp.category = data_temp(i).resp.category;

            Syl = find(n(i,1:6));
            if isempty(Syl)
                Syl = 0;
            end
            switch Syl
                case 1 % CV response
                    C1 = find(n(i,22:end) == 1);
                    for c = 1:length(C1)
                        resp.R(c).r = C_sequence{C1(c)};
                        resp.R(c).category = 'C';
                    end
                    V1 = find(n(i,7:21) == 1);
                    for v = 1:length(V1)
                        resp.R(v+length(C1)).r = V_sequence{V1(v)};
                        resp.R(v+length(C1)).category = 'V';
                    end

                case 2 % VC response
                    V1 = find(n(i,7:21) == 1);
                    for v = 1:length(V1)
                        resp.R(v).r = V_sequence{V1(v)};
                        resp.R(v).category = 'V';
                    end
                    C1 = find(n(i,22:end) == 1);
                    for c = 1:length(C1)
                        resp.R(c+length(V1)).r = C_sequence{C1(c)};
                        resp.R(c+length(V1)).category = 'C';
                    end

                case 3 % CVC response
                    if resp.category == 'CV'
                        C1 = find(n(i,22:end) == 1);
                        for c = 1:length(C1)
                            resp.R(c).r = C_sequence{C1(c)};
                            resp.R(c).category = 'C';
                        end
                        V1 = find(n(i,7:21) == 1);
                        for v = 1:length(V1)
                            resp.R(v+length(C1)).r = V_sequence{V1(v)};
                            resp.R(v+length(C1)).category = 'V';
                        end
                    else
                        V1 = find(n(i,7:21) == 1);
                        for v = 1:length(V1)
                            resp.R(v).r = V_sequence{V1(v)};
                            resp.R(v).category = 'V';
                        end
                        C1 = find(n(i,22:end) == 2);
                        for c = 1:length(C1)
                            resp.R(c+length(V1)).r = C_sequence{C1(c)};
                            resp.R(c+length(V1)).category = 'C';
                        end
                    end

                case 4 % VCV response
                    if resp.category == 'CV'
                        C1 = find(n(i,22:end) == 1);
                        for c = 1:length(C1)
                            resp.R(c).r = C_sequence{C1(c)};
                            resp.R(c).category = 'C';
                        end
                        V1 = find(n(i,7:21) == 2);
                        for v = 1:length(V1)
                            resp.R(v+length(C1)).r = V_sequence{V1(v)};
                            resp.R(v+length(C1)).category = 'V';
                        end
                    else
                        V1 = find(n(i,7:21) == 1);
                        for v = 1:length(V1)
                            resp.R(v).r = V_sequence{V1(v)};
                            resp.R(v).category = 'V';
                        end
                        C1 = find(n(i,22:end) == 1);
                        for c = 1:length(C1)
                            resp.R(c+length(V1)).r = C_sequence{C1(c)};
                            resp.R(c+length(V1)).category = 'C';
                        end
                    end

                case 5 % CCV response
                    x = '';
                    C1 = find(n(i,22:end) == 1);
                    for c = 1:length(C1)
                        if c > 1
                            x = [x ',(' C_sequence{C1(c)} ')'];
                        else
                            x = [x '(' C_sequence{C1(c)} ')'];
                        end
                    end
                    C1 = find(n(i,22:end) == 2);
                    for c = 1:length(C1)
                        if c > 1
                            x = [x ',(' C_sequence{C1(c)} ')'];
                        else
                            x = [x '(' C_sequence{C1(c)} ')'];
                        end
                    end
                    V1 = find(n(i,7:21) == 1);
                    for v = 1:length(V1)
                        if v > 1
                            x = [x ',(' V_sequence{V1(v)} ')'];
                        else
                            x = [x '(' V_sequence{V1(v)} ')'];
                        end
                    end
                    resp = resolve_response(x,data_IPA(L+i).stim);

                case 6 % VCC response
                    x = '';
                    V1 = find(n(i,7:21) == 1);
                    for v = 1:length(V1)
                        if v > 1
                            x = [x ',(' V_sequence{V1(v)} ')'];
                        else
                            x = [x '(' V_sequence{V1(v)} ')'];
                        end
                    end
                    C1 = find(n(i,22:end) == 1);
                    for c = 1:length(C1)
                        if c > 1
                            x = [x ',(' C_sequence{C1(c)} ')'];
                        else
                            x = [x '(' C_sequence{C1(c)} ')'];
                        end
                    end
                    C1 = find(n(i,22:end) == 2);
                    for c = 1:length(C1)
                        if c > 1
                            x = [x ',(' C_sequence{C1(c)} ')'];
                        else
                            x = [x '(' C_sequence{C1(c)} ')'];
                        end
                    end
                    resp = resolve_response(x,data_IPA(L+i).stim);
                otherwise
            end
            data_IPA(L+i).resp = resp;       
        end
    else
        disp(['File IPATranscript/IPATranscription_' subid '_' m '-' d '-07.xls not found'])
    end
    L = L + N(f);
end

if Save
    save(['IPAData_' subid '.mat'], 'data_IPA')
end
