clear all

symbols = {'@', 'A', 'C', 'D', 'E', 'G', 'I', 'J', 'O', 'R', 'S', 'T', 'U',...
    'W', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'k', 'l',...
    'm', 'n', 'o', 'p', 'r', 's', 't', 'u', 'v', 'w', 'y', 'z'};
symbols_C = {'C', 'D', 'G', 'J', 'S', 'T', 'Z', 'b', 'd', 'f', 'g', 'h', 'k',...
    'l', 'm', 'n', 'p', 'r', 's', 't', 'v', 'w', 'y', 'z'};
symbols_V = {'@', 'A', 'E', 'I', 'O', 'R', 'U', 'W', 'Y', 'a', 'c', 'e', 'i',...
    'o', 'u'};

subid = {'Laura','Tina','Matt','norene','angela','Tony','Lucas','Teddy','Shauna','Evan','Edward','Savannah','Miguel','Carly','Bob'};

for s = 1:length(subid)
    clear N p
    load(['Data_' subid{s} '.mat'])
    Table(s).subid = subid(s);
%     % initial position
%     Table(i).p = sum(squeeze(p(1,:,:)),2);
%     Table(i).N = sum(squeeze(N(1,:,:)),2);
%     % final position
%     Table(i).p = sum(squeeze(p(2,:,:)),2);
%     Table(i).N = sum(squeeze(N(2,:,:)),2);
    % mean values
    Table(s).p = sum(squeeze(sum(p,1)),2);
    Table(s).N = sum(squeeze(sum(N,1)),2);

    % Make SCO Profile for the child
    f = fopen(['SCOProfile_' subid{s} '.txt'],'w');
    fprintf(f,'%s : SCO Task\r\n', subid{s});
    
    % Initial position
    [P, I] = sort(sum(p(1,:,:),3)./sum(N(1,:,:),3));
    fprintf(f,'Initial Position \r\n');
    fprintf(f,' , Total, ');
    for i = 1:length(symbols)
        i_sort = I(i);
        fprintf(f,'%s, ', symbols{i_sort});
    end
    fprintf(f,'\r\n');
    for i = 1:length(symbols)
        i_sort = I(i);
        fprintf(f,'%s, %i/%i=%i%c, ',symbols{i_sort},sum(p(1,i_sort,:)),sum(N(1,i_sort,:)),round(P(i)*100),'%');
        for j = 1:length(symbols)
            j_sort = I(j);
            if N(1,i_sort,j_sort)
                fprintf(f,'%i/%i=%i%c, ',p(1,i_sort,j_sort),N(1,i_sort,j_sort),round(p(1,i_sort,j_sort)/N(1,i_sort,j_sort)*100),'%');
            else
                fprintf(f,', ');
            end
        end
        fprintf(f,'\r\n');
    end

    % Initial position
    [P, I] = sort(sum(p(2,:,:),3)./sum(N(2,:,:),3));
    fprintf(f,'Final Position \r\n');
    fprintf(f,' , Total, ');
    for i = 1:length(symbols)
        i_sort = I(i);
        fprintf(f,'%s, ', symbols{i_sort});
    end
    fprintf(f,'\r\n');
    for i = 1:length(symbols)
        i_sort = I(i);
        fprintf(f,'%s, %i/%i=%i%c, ',symbols{i_sort},sum(p(2,i_sort,:)),sum(N(2,i_sort,:)),round(P(i)*100),'%');
        for j = 1:length(symbols)
            j_sort = I(j);
            if N(1,i_sort,j_sort)
                fprintf(f,'%i/%i=%i%c, ',p(2,i_sort,j_sort),N(2,i_sort,j_sort),round(p(2,i_sort,j_sort)/N(1,i_sort,j_sort)*100),'%');
            else
                fprintf(f,', ');
            end
        end
        fprintf(f,'\r\n');
    end

    p = squeeze(sum(p,1));
    N = squeeze(sum(N,1));

    % Overall
    [P, I] = sort(sum(p,2)./sum(N,2));
    fprintf(f,'Overall (Position-independent) \r\n');
    fprintf(f,' , Total, ');
    for i = 1:length(symbols)
        i_sort = I(i);
        fprintf(f,'%s, ', symbols{i_sort});
    end
    fprintf(f,'\r\n');
    for i = 1:length(symbols)
        i_sort = I(i);
        fprintf(f,'%s, %i/%i=%i%c, ',symbols{i_sort},sum(p(i_sort,:)),sum(N(i_sort,:)),round(P(i)*100),'%');
        for j = 1:length(symbols)
            j_sort = I(j);
            if N(i_sort,j_sort)
                fprintf(f,'%i/%i=%i%c, ',p(i_sort,j_sort),N(i_sort,j_sort),round(p(i_sort,j_sort)/N(i_sort,j_sort)*100),'%');
            else
                fprintf(f,', ');
            end
        end
        fprintf(f,'\r\n');
    end

    
    fclose(f);
end

% break

% f = fopen('ScoreTable_Initial.txt','w');
% f = fopen('ScoreTable_Final.txt','w');
f = fopen('ScoreTable.txt','w');

fprintf(f,'%s,','Phone');
for i = 1:length(subid)
    fprintf(f,'%s,',subid{i});
end
fprintf(f,'\r\n');

for j = 1:length(symbols)
    fprintf(f,'%s,',symbols{j});
    for i = 1:length(subid)
        fprintf(f,'%i/%i=%2.2f,',Table(i).p(j),Table(i).N(j),(Table(i).p(j)/Table(i).N(j))*100);
    end
    fprintf(f,'\r\n');
end
fprintf(f,'%s,','Total');
for i = 1:length(subid)
    fprintf(f,'%i/%i=%2.2f,',sum(Table(i).p),sum(Table(i).N),(sum(Table(i).p)/sum(Table(i).N))*100);
end

fclose(f);

