
clear all

symbols = {'@', 'A', 'C', 'D', 'E', 'G', 'I', 'J', 'O', 'R', 'S', 'T', 'U',...
    'W', 'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'k', 'l',...
    'm', 'n', 'o', 'p', 'r', 's', 't', 'u', 'v', 'w', 'y', 'z'};
symbols_C = {'C', 'D', 'G', 'J', 'S', 'T', 'Z', 'b', 'd', 'f', 'g', 'h', 'k',...
    'l', 'm', 'n', 'p', 'r', 's', 't', 'v', 'w', 'y', 'z'};
symbols_V = {'@', 'A', 'E', 'I', 'O', 'R', 'U', 'W', 'Y', 'a', 'c', 'e', 'i',...
    'o', 'u'};

subid_all = {'Laura','Matt','Tina','Angela','Norene','Tony','Teddy','Shauna','Evan','Edward','Savannah','Miguel','Carly','Bob'};


string = ['\d+\s+(?<score>\d)\s+(?<stim>\d)\s+(?<resp>\d)\s+\S+\s+\d*'...
    '\s*\{(?<tgt1>\S)(?<tgt2>\S) , (?<msk1>\S)(?<msk2>\S) \},'...
    '\s+\[(?<fname1>s_\w\d+_\w+\.twav); (?<fname2>s_\w\d+_\w+\.wav);'...
    ' (?<fname3>s_\w\d+_\w+\.wav) \]']; 
string1 = '\d+\s+(?<score>\d)\s+(?<stim>\d)\s+(?<resp>\d)\s+\S+\s+\d+';
string2 = '\s+\{(?<tgt1>\S)(?<tgt2>\S)\s*, (?<msk1>\S)(?<msk2>\S)\s*\},';
string3 = '\s+\[(?<fname1>s_\w\d+_\w+\.wav); (?<fname2>s_\w\d+_\w+\.wav); (?<fname3>s_\w\d+_\w+\.wav) \]';

for s = length(subid_all)
    
subid = subid_all{s};
clear data

d = dir(['../data/' subid '*.log']);
temp = dir(['../data/' lower(subid) '*.log']);
d(end + [1:length(temp)]) = temp;
    
L = 0;
for i = 1:length(d)
    [dummy, dummy2] = unix(['grep { ../data/' d(i).name ' | wc -l']);
    if str2num(dummy2) > 1
        f = fopen(['../data/' d(i).name], 'r');
        x = fscanf(f, '%c');
        fclose(f);
	temp = regexp(x, '\d+\s+(?<score>\d+)\s+\d\s+\d\s+\d\d:\d\d:\d\d','names');
	temp1 = regexp(x,'\{\s*(?<tgt1>\S)(?<tgt2>\S)\s*, (?<msk1>\S)(?<msk2>\S)\s*\}','names');
        N = length(temp1);
	data(L+[1:N]) = temp1;
	if str2num(temp(end).score) > 1
		[a, b, c] = unique({temp.score});
		score_temp = zeros(1,N);
		score_temp(b) = 1;
	else
		score_temp = double(strcmp('1',{temp.score}));
	end
	score(L+[1:N]) = score_temp;
	L = L + N;
    disp([d(i).name ': ' num2str(length(find(score_temp))) '/'...
        num2str(N) '=' num2str(length(find(score_temp))/N)])
    end
end
% 
% break

phones = struct();
N = zeros(2,length(symbols),length(symbols));
p = zeros(2,length(symbols),length(symbols));
for i = 1:length(data)
    if data(i).tgt1 == data(i).msk1
        msk(i) = data(i).msk2;
        tgt(i) = data(i).tgt2;
        var_pos(i) = 2;
    else
        msk(i) = data(i).msk1;
        tgt(i) = data(i).tgt1;
        var_pos(i) = 1;
    end
    data(i).score = score(i);
    data(i).var_pos = var_pos(i);
    index_tgt = find(strcmp(symbols,tgt(i)));
    index_msk = find(strcmp(symbols,msk(i)));
    index = find(strcmp(symbols,tgt(i)) | strcmp(symbols,msk(i)));
    N(var_pos(i), index_tgt, index_msk) = N(var_pos(i), index_tgt, index_msk) + 1;
    p(var_pos(i), index_tgt, index_msk) = p(var_pos(i), index_tgt, index_msk) + score(i);
end

e = N - p;
f1 = fopen(['scores_' subid '.txt'],'w');
f2 = fopen(['errors_' subid '.txt'],'w');
fprintf(f1,'%s\r\n',subid);
fprintf(f2,'%s\r\n',subid);
for i = 1:length(symbols)
    fprintf(f1,'%s: %i/%i = %0.2f\r\n', symbols{i},sum(sum(p(:,i,:),1)),...
    sum(sum(N(:,i,:),1)),sum(sum(p(:,i,:),1))/sum(sum(N(:,i,:),1)));
    fprintf(f2,'%s: %i/%i = %0.2f\r\n', symbols{i},sum(sum(e(:,i,:),1)),...
    sum(sum(N(:,i,:),1)),sum(sum(e(:,i,:),1))/sum(sum(N(:,i,:),1)));
end
fclose(f1);
fclose(f2);
save(['Data_' subid '.mat'], '-v6', 'N', 'p','data','symbols')

end